import { DisposableSymbols } from './symbols.js';
import { MaybePromise } from './utils.js';
export declare class PonyfillAsyncDisposableStack implements AsyncDisposableStack {
    private callbacks;
    get disposed(): boolean;
    use<T extends AsyncDisposable | Disposable | null | undefined>(value: T): T;
    adopt<T>(value: T, onDisposeAsync: (value: T) => MaybePromise<void>): T;
    defer(onDisposeAsync: () => MaybePromise<void>): void;
    move(): AsyncDisposableStack;
    disposeAsync(): Promise<void>;
    private _error?;
    private _iterateCallbacks;
    [DisposableSymbols.asyncDispose](): Promise<void>;
    readonly [Symbol.toStringTag]: string;
}
